<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;

use App\Models\Providers\Provider;
use App\Models\Customers\Customer;
use DB;

class AppointmentNoShow extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'appointment:noshow';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'appointment no show for customer and provider.';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {        
        $appointments = DB::table('appointments')
                        ->where('appointment_cancel','no')
                        //->where('date_time', '>=', strtotime(date("Y-m-d H:i")))
                        ->orderBy('id', 'desc')
                        ->get();
       
        if($appointments->count())
        {
            foreach($appointments as $key => $appointment) 
            {
               $appointmentDateTime = strtotime("+10 minutes", $appointment->date_time);
               
               if($appointmentDateTime == strtotime(date("Y-m-d H:i"))){
                    $appointmentNoShow = DB::table('appointment_noshow')->where('appointment_id',$appointment->id)->first();
                    if(empty($appointmentNoShow)){
                        DB::table('appointment_noshow')->insert(['appointment_id' => $appointment->id]);
                    }
               }
            }
            echo "Appointment no show cummand run successfully!";
        }
    }
}
