<?php

namespace App\Console\Commands;

use Illuminate\Console\Command;

use App\Models\CustomPushes\CustomPush;
use App\Models\Vendors\Vendor;
use App\Models\Customers\Customer;


use App\Jobs\SendMailJob;

class PushCommand extends Command
{
    /**
     * The name and signature of the console command.
     *
     * @var string
     */
    protected $signature = 'send:push';

    /**
     * The console command description.
     *
     * @var string
     */
    protected $description = 'Send Push Notification';

    /**
     * Create a new command instance.
     *
     * @return void
     */
    public function __construct()
    {
        parent::__construct();
    }

    /**
     * Execute the console command.
     *
     * @return mixed
     */
    public function handle()
    {
        $date = date('Y-m-d H:i:s');

        $datas = CustomPush::where('schedule_at','<=',$date)->where('sent',0)->get();
       
        if($datas) {
            foreach( $datas as $data) {
                if($data->send_to == 'customers') {

                    $user = Customer::select('first_name','last_name','email')->where('id',$data->user_id)->first();
    
                } else if( $data->sent_to == 'vendors') {
                   
                    $user = Vendor::select('first_name','last_name','email')->where('id',$data->user_id)->first();
    
                }
    
                //dd($user);
    
                $greetingAdmin = 'Dear '.$user->first_name.' '.$user->last_name;
                $bodyAdmin     =  $data->message;
                $typeAdmin     = 'Notification'; 
        
                $userNotification = new SendMailJob($user->email, $greetingAdmin, $bodyAdmin, $typeAdmin);
                dispatch($userNotification);
    
                CustomPush::where('id',$data->id)->update(['sent'=>'1']);     
            }

        }
    }
}
