<?php

namespace App\Http\Controllers\v4\Notification;

use Exception;
use Throwable;
use Carbon\Carbon;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use App\Models\Users\User;
use App\Models\Notifications\Notification;
use Illuminate\Support\Facades\DB;


class NotificationController extends Controller
{
    /**
     * The user repository implementation.
     *
     * @var UserRepository
     */
    //protected  $notification;
    protected  $user_id;
    protected  $role_fk;
    protected  $users;

    public function __construct(Request $request, User $users) {
        //$this->notification = $notification;
        $this->user_id = $request->user_id;
        $this->role_fk = $request->role_fk;
        $this->users = $users;

    }
    
    public function index(Request $request) 
    {
        $id    = $request->get('notifiable_id');
        $role  = $request->get('role');
        $order = "desc";
        $limit = isset($request->limit) && $request->limit > 500 ? 25 : $request->limit;
        
        $obj = Notification::select('id','notifiable_id', 'role', 'data AS message', 
                'read_at', 'created_at', 'updated_at')->where('notifiable_id','!=','');
                
        if(isset($id) && $id!=''){
            
            $result = $obj->where('notifiable_id',$id);
        }

        if(isset($role) && $role!=''){
            
            $result = $obj->where('role', $role);
        }

        if(isset($request->order) && strtolower($request->order) == "asc") {
            
            $order  = $request->order;  
        }

        if(isset($request->read) && $request->read != "") {
            if($request->read == 'yes') {
                $obj  =  $obj->whereNotNull('read_at');  
            } else if($request->read == 'no') {
                $obj  =  $obj->whereNull('read_at');  
            }        
        }
        
        $result = $obj->orderBy('created_at', $order)->paginate($limit);

        $count  = $obj->whereNull('read_at')->count();
        
        return response()->json([
            'status' => config('service.USER_API.MESSAGE.SUCCESS_STATUS'), 
            'message' => config('service.USER_API.MESSAGE.USER_NOTIFICATION'), 
            'unread_notification' => $count,
            'records' => $result]);
    }

    public function MarkAsRead($id) {
        $notification = Notification::where('id',$id)->update(['read_at' => Carbon::now()]);
        return response()->json(['status'=> config('service.USER_API.MESSAGE.SUCCESS_STATUS'), 'message' => config('service.USER_API.MESSAGE.NOTIFICATION_MARKASREAD')]);
    }


    private function getColumnName() {
        $address = $this->notification::first();
        if(!empty($address) && $address!="") {
            return array_keys($address->toArray());
        }
        return ['id'];
    }

    
}
