<?php

namespace App\Http\Controllers\v4\Settings;
use Illuminate\Support\Facades\Schema;
use Exception;
use Throwable;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Storage;
use App\Http\Controllers\Controller;

use App\Models\Settings\Setting;
use App\Models\Settings\App_version;
use App\Models\Settings\Evergreen_category;
use App\Models\Settings\Evergreen_video;

use Validator;
use DB;
use \SimpleXMLElement;


class SettingCotroller extends Controller
{
    public function index(Request $request) {       
        try {

            $key = Setting::orderBy('id')->pluck('name')->toArray();            
            $value = Setting::orderBy('id')->pluck('value')->toArray();
            $result = array_combine($key,$value);

            return response()->json(['status' => config('service.USER_API.MESSAGE.SUCCESS_STATUS'), 'message' => 'Setting List.', 'records' => $result]);
        } catch (Exception $e) {
            return response()->json(['status' => config('service.USER_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        } catch (Throwable $e) {
            return response()->json(['status' => config('service.USER_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        }

    }


    public function update(Request $request) {  
        $this->validate($request, [
            'params' => 'required',
        ]);
             
        try {
            $setting = '';
            $params = $request->params;
            if( !empty($params) && is_array($params) ) {
                foreach ($params as $key => $val) {
                    $setting = Setting::where('name','=', $key);
                    if($setting->exists() && !empty($val)) {
                        $upd['value'] = $val;
                        $setting->update($upd);
                    }
                }
            }
            // print_r($params);
            // die;

            return response()->json(['status' => "success", 'message' => 'Setting updated.', 'records' => $setting]);
        } catch (Exception $e) {
            return response()->json(['status' => config('service.USER_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        } catch (Throwable $e) {
            return response()->json(['status' => config('service.USER_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        }

    }

    public function appConfigurationSave(Request $request)
    {
         $input = $request->all();

         try {

            $setting = '';
            $params = $request->all();
            if($request->has('logo')) {
                  //image upload
                  $imageName = rand(10000, 9999999) . '-' . time() . '.' . request()->logo->getClientOriginalExtension();          
                  request()->logo->move(storage_path('logo'),$imageName);
                  $data['image'] = $imageName; 

                  $setting = Setting::where('name','=', 'logo');
                  if($setting->exists()) {
                         $upd['value'] = $data['image'];
                         $setting->update($upd);
                  } 
            }
            
            if(!empty($params) && is_array($params) ) {
                foreach ($params as $key => $val) {
                    if($key == "logo"){
                       continue;
                    }
                    $setting = Setting::where('name','=', $key);
                    if($setting->exists() && !empty($val)) {
                        $upd['value'] = $val;
                        $setting->update($upd);
                    }
                }
            }

         return response()->json(['status' => 'success', 'message' =>'Setting update', 'records' => $input]);
         
         } catch (Exception $e) {
            return response()->json(['status' => config('service.USER_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        } catch (Throwable $e) {
            return response()->json(['status' => config('service.USER_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        }

    }

    public function adminSettingValue(Request $request)
    {
        $name = $request->name;
        if($name == "logo"){
            $logo   =  Setting::where('name',$name)->value('value');
            $url    =  storage_path('logo/'.$logo);
            $result = image_to_base64($url);

        }else{
            $result =  Setting::where('name',$name)->value('value');
        }
        if(!empty($result))
        {

            return response()->json(['status' => "success", 'message' => 'setting value list successfully.', 'records' => $result]);
        }
        else
        {
            return response()->json(['status' => "failed", 'message' => 'setting value not found.', 'records' => null]);
        }
    }

    public function getLatestAppVersion(Request $request)
    {
        try {

            $message = array(
                'platform.required' => config('service.CUSTOMER_API.VALIDATION.PLATFORM_REQUIRED'),
                'app.required' => config('service.CUSTOMER_API.VALIDATION.APP_REQUIRED')
            );
            $validator = Validator::make($request->all(), [
                'platform' => 'required',
                'app' => 'required',
            ]);
            if($validator->fails()){
                return response()->json(['success' => false,'message' => $validator->errors()->first()]);
            }else{
                $platform  = $request->platform;
                $app = $request->app;
                $ColumnName  = $platform.'_'.$app.'_app';
                $AppData = App_version::select($ColumnName)->first();  
                return response()->json(['status' => "success", 'message' => 'App latest version data.', 'version' => $AppData->$ColumnName]);
            }
        } catch (Throwable $e) {
            return response()->json(['status' => 'error', 'message' => $e->getMessage(), 'version' => []]);
        }
    }

    public function getLatestAppVersionAll()
    {
        try {

            $AppData = App_version::first();  
            return response()->json(['status' => "success", 'message' => 'App latest version data.', 'version' => $AppData]);
            
        } catch (Throwable $e) {
            return response()->json(['status' => 'error', 'message' => $e->getMessage(), 'version' => []]);
        }
    }
    
    public function updateLatestAppVersion(Request $request)
    {
        try {

             date_default_timezone_set('UTC');
             $validator = Validator::make($request->all(), [
                 'android_provider_app' => 'required',
                 'android_consumer_app' => 'required',
                 'ios_consumer_app' => 'required',
                 'ios_provider_app' => 'required',
             ]);
             if($validator->fails()){
                 return response()->json(['status' => 'error','message' => $validator->errors()->first()]);
             }else{
               
                $App_version = App_version::findOrFail(1);
                DB::beginTransaction();
                $input = $request->all();
                $inputs['android_provider_app'] = $input['android_provider_app'];
                $inputs['android_consumer_app'] = $input['android_consumer_app'];
                $inputs['ios_consumer_app'] = $input['ios_consumer_app'];
                $inputs['ios_provider_app'] = $input['ios_provider_app'];
                $inputs['modifiedAt'] = date('Y-m-d H:i:s');
                $save  = $App_version->update($inputs);
                DB::commit();
                return response()->json(['status' => "success", 'message' => 'App latest version data.', 'records' => $input]);
            }
        } catch (Throwable $e) {
            return response()->json(['status' => 'error', 'message' => $e->getMessage(), 'version' => []]);
        }
    }

    public function evergreen_store(Request $request){
        
        // print_r($request->title);exit;
        try {
                // return response()->json($request->all());
                $input['title']=$request->title;
                $input['status']=1;
                
                
                $Evergreen_category =  Evergreen_category::create($input);
                if($Evergreen_category){
                    // print_r($request->filename);exit;
                    $videoName = rand(10000, 9999999) . '-' . time() . '.' . pathinfo($request->video, PATHINFO_EXTENSION);
                    // return response()->json($videoName);
                    if(request()->apidata){
                        $apidata=request()->apidata;
                    }else{
                        $apidata=request()->video;
                    }
                    
                    $directoryName = "Evergreenvideo";
                    uploadFile($apidata,$directoryName,$videoName);
                    $input_video['title_id'] =  $Evergreen_category->id;
                    $input_video['url'] =  $videoName;
                    $input_video['status'] =  1;
                    $Evergreen_video =  Evergreen_video::create($input_video);
                
                

                return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.SUCCESS_STATUS'), 'message' => 'Created Successfully', 'records' => $Evergreen_category]);
            }
        } catch (Exception $e) {
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        } catch (Throwable $e) {
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        }
        
    }

    public function evergreen_list(Request $request){
        // echo "hello";exit;
        // try
        // {
        //     $order = "desc";
        //     $limit = isset($request->limit) ? $request->limit : 25;
         
        //     if (isset($request->order) && strtolower($request->order) == "asc") {
        //         $order = $request->order;
        //     }
        //     $order_by_column_name = "id";
        //     if ($request->filled('order_by_column_name')) {
        //         if (in_array($request->order_by_column_name, $this->getColumnName())) {
        //             $order_by_column_name = $request->order_by_column_name;
        //         }
        //     }
        //     $customers = Evergreen_category::with(['evergreen_videos'])
        //     ->where(function ($q) use ($request) {
        //         // Global searching...
        //         if (isset($request->search) && !empty($request->search) && $request->search != "") {
        //             if (!empty($this->getColumnName())) {
        //                 foreach ($this->getColumnName() as $key => $col) {
        //                     if ($key == 0) {
        //                         $q->where($col, 'like', '%' . $request->search . '%');
        //                         $q->orWhere('title', 'like', '%' . strtolower($request->search) . '%');
                                
        //                     } else {
                           
                               
        //                         $q->orWhere($col, 'like', '%' . encryptString($request->search) . '%');
                             
        //                     }
        //                 }
        //             }
        //         }
        //         // filters
                
        //     })
        //     // ->where('status',1)
        //     ->orderBy($order_by_column_name, $order)
        //     ->paginate($limit);
         

        //     return response()->json(['status' => config('service.CUSTOMER_API.MESSAGE.SUCCESS_STATUS'), 'message' =>  config('service.CUSTOMER_API.MESSAGE.CUSTOMER_LISTING'), 'records' => $customers]);
        //     }
        //     catch (Exception $e) {
        //         return response()->json(['status' => config('service.CUSTOMER_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        //     }
        //     catch (Throwable $e) {
        //         return response()->json(['status' => config('service.CUSTOMER_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        //     }


        try
        {
            $order = "desc";
            $limit = isset($request->limit) ? $request->limit : 25;
            /*if ($limit > env('MAX_PER_PAGE')) {
            $limit = 25;
            }*/
            if (isset($request->order) && strtolower($request->order) == "asc") {
                $order = $request->order;
            }
            $tableName = 'evergreen_categories';

            // Get the column names of the 'users' table
            $columnNames = Schema::getColumnListing($tableName);
            // print_r($columnNames);exit;
            $order_by_column_name = "id";
            if ($request->filled('order_by_column_name')) {
                if (in_array($request->order_by_column_name, $columnNames)) {
                    $order_by_column_name = $request->order_by_column_name;
                }
            }
            $customers = Evergreen_category::with(['evergreen_videos'])
            ->where(function ($q) use ($request) {
                // Global searching...
                if (isset($request->search) && !empty($request->search) && $request->search != "") {
                    if (!empty($columnNames)) {
                        foreach ($columnNames as $key => $col) {
                            if ($key == 0) {
                                $q->where($col, 'like', '%' . encryptString($request->search) . '%');
                                $q->orWhere('title', 'like', '%' . strtolower($request->search) . '%');
                                
                            } else {
                                $q->orWhere('title', 'like', '%' . strtolower($request->search) . '%');
                                
                            }
                        }
                    }
                }
                // filters
                if($request->filled('title')) {
                    $title = $request->title;
                    
                    $q->where('title', 'like', '%'.ucfirst(strtolower($title)).'%');
                   
                }
                
            })
            // ->where(function ($q) use ($request) {
            //     // Column wise searching filter ...
            //     $allowableColumn = $columnNames;
            //     if (isset($request->column_name) && !empty($request->column_name) && $request->column_name != "" && in_array($request->column_name, $allowableColumn)) {
            //         $q->where($request->column_name, 'like', '%' . $request->column_value . '%');
            //     }
            // })
            ->orderBy($order_by_column_name, $order)
            ->paginate($limit);

            if (empty($customers)) {
                throw new Exception(config('service.EVERGREEN_API.MESSAGE.CUSTOMER_NOT_FOUND'));
            }
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.SUCCESS_STATUS'), 'message' =>  config('service.CUSTOMER_API.MESSAGE.CUSTOMER_LISTING'), 'records' => $customers]);
            }
            catch (Exception $e) {
                return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
            }
            catch (Throwable $e) {
                return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
            }
    }

    public function get_evergreen_content($id){
        try {

            // $evergreen = Evergreen_category::with(['evergreen_videos'])->where('id',$id)->first();  
            $data['evergreen'] =   $EvergreenCategory = Evergreen_category::where('id',$id)->first();
            
                $videos = Evergreen_video::where('title_id',$EvergreenCategory->id)
                ->first();
                $EvergreenCategory->evergreen_videos = $videos;
            return response()->json(['status' => "success", 'message' => 'Evergreen Content.', 'version' => $EvergreenCategory]);
            
        } catch (Throwable $e) {
            return response()->json(['status' => 'error', 'message' => $e->getMessage(), 'version' => []]);
        }
    }
    public function activeInactive(Request $request, $id) 
    {
        //has_scope('cms.pages.write');
        $this->validate($request,[
            'status' => 'required',
        ]);
        try {
            $result = Evergreen_category::findOrFail($id);
            $result->status = $request->status;
            $result->save();

         
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.SUCCESS_STATUS'), 'message' => config('service.EVERGREEN_API.MESSAGE.EVERGREEN_STATUS_ACTIVE'),'action'=>$request->status]);
    
            // return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.EVERGREEN_STATUS_INACTIVE'), 'message' => config('service.EVERGREEN_API.MESSAGE.EVERGREEN_STATUS_ACTIVE'),'action'=>$request->status]);
         
          
        }
        catch (Exception $e) {
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []], 400);
        }
        catch (Throwable $e) {
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []], 400);
        }
    }

    public function evergreenUpdate(Request $request){

        

        try {
            
            $validator = Validator::make($request->all(), [
                'title' => 'required',
                'update_flag' => 'required',
                'cat_id' => 'required',
            ]);

            if($validator->fails()){
                return response()->json(['success' => false,'message' => $validator->errors()->first()]);
            }else{

                $input['title']=$request->title;
                $input['update_flag']=$request->update_flag;
                $input['cat_id']=$request->cat_id;
                $input['status']=1;
                
         
                if($input['update_flag'] == 1){
         
                    $videoName = rand(10000, 9999999) . '-' . time() . '.' . pathinfo($request->video, PATHINFO_EXTENSION);
                    // return response()->json($videoName);
                    if(request()->apidata){
                        $apidata=request()->apidata;
                    }else{
                        $apidata=request()->video;
                    }
                    
                    $directoryName = "Evergreenvideo";
                    uploadFile($apidata,$directoryName,$videoName);

                    $document_file=Evergreen_video::where('title_id',$input['cat_id'])->first();
                    remove_image_s3_bucket($directoryName,$document_file->url);
                                
                    $input_video['url'] =  $videoName;
                    $input_video['status'] =  1;
                    $Evergreen_video = Evergreen_video::where('title_id', $input['cat_id'])->update($input_video);

                }

                $input_cat['title'] = $input['title'];
                $input_cat['status'] =  1;
                $Evergreen_video = Evergreen_category::where('id', $input['cat_id'])->update($input_cat);
                
                return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.SUCCESS_STATUS'), 'message' => 'Updated Successfully']);
            
        }
            
        } catch (Exception $e) {
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        } catch (Throwable $e) {
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'records' => []]);
        }
        
    }

    public function evergreendelete(Request $request){
        try {
            $directoryName = "Evergreenvideo";
            $document_file=Evergreen_video::where('title_id',$request->id)->first();
            remove_image_s3_bucket($directoryName,$document_file->url);
            $vergreen_video= Evergreen_video::where('title_id',$request->id)->delete();
            DB::beginTransaction();

            $evergreen_category = Evergreen_category::find($request->id);
            $evergreen_category->delete();
            
            
            DB::commit();

            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.SUCCESS_STATUS'), 'message' => 'Evergreen Content Deleted Successfully']);
        }
        catch (Exception $e) {
             DB::rollBack();
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'result' => []]);
        }
        catch (Throwable $e) {
             DB::rollBack();
            return response()->json(['status' => config('service.EVERGREEN_API.MESSAGE.ERROR_STATUS'), 'message' => $e->getMessage(), 'result' => []]);
        }

    }
    
}
