<?php

namespace App\Jobs;

use Illuminate\Support\Facades\Mail;
use Exception;
use App\Models\Business\BusinessAccessCode;

class GenerateAccessCodeJob extends Job
{
    protected $access_code;
    protected $business_id;
    protected $id;

    /**
     * Create a new job instance.
     *
     * @param int $access_code
     * @param int $business_id
     * @param int $id
     * @return void
     */
    public function __construct($access_code, $business_id, $id)
    {
        $this->access_code = $access_code;
        $this->business_id = $business_id;
        $this->id = $id;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $accessCodes = [];

        for ($i = 0; $i < $this->access_code; $i++) {
            $access_code = $this->business_id . '-' . rand(1000, 9999) . '-' . rand(1000, 9999) . '-' . rand(1000, 9999);
            $accessCodes[] = [
                'business_id' => $this->id,
                'access_code' => $access_code,
                'status' => true,
            ];
        }

        BusinessAccessCode::insert($accessCodes);
    }
}
