<?php

namespace App\Jobs;
use Illuminate\Support\Facades\Mail;
use Exception;

class SendForgotMailJob extends Job
{
	protected $email;
	protected $greeting;
    protected $body;
    protected $type;
    protected $link;
    protected $link_expire_time;
    /**
     * Create a new job instance.
     *
     * @return void
     */
    public function __construct($email,$greeting,$body,$type, $link, $link_expire_time)
    {
        $this->email    =  $email;
		$this->greeting =  $greeting;
        $this->body     =  $body;
        $this->type     =  $type;
        $this->link     =  $link;
        $this->link_expire_time  =  $link_expire_time;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    { 
        $data['greeting'] = $this->greeting;
        $data['body']     = $this->body;
        $data['link']     = $this->link;
        $data['link_expire_time']  = $this->link_expire_time;
		$user_email   = $this->email;
        $subject      = $this->type;
		
		
        Mail::send('emails.Users.reset_password',['data'=>$data], function($message) use ($user_email,$subject) {
                $message->to($user_email);
                $message->subject($subject);
        });
    }
}
