<?php

namespace App\Jobs;

use Illuminate\Support\Facades\Mail;
use Exception;


class SendTwoFactorJob extends Job
{
    /**
     * Create a new job instance.
     *
     * @return void
     */
    protected $name;
    protected $email;
    protected $code;
    public function __construct($name,$email,$code)
    {
        
         $this->name = $name;
         $this->email = $email;
         $this->code = $code;
    }

    /**
     * Execute the job.
     *
     * @return void
     */
    public function handle()
    {
        $name = $this->name;
        $email = $this->email;
        $code = $this->code;

        Mail::send('emails.otp_mail',['code'=>$code,'name'=>$name], function($message) use ($email) {
                $message->to($email);
                $message->subject('Two factor authentication.');
        });
    }

}
