<?php

namespace App\Models\AppointmentManagement;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class Appointment extends Model
{
    protected $table = 'appointments';

    protected $fillable = [
        'appointment_id ', 
        'customer_id', 
        'provider_id', 
        'date', 
        'day', 
        'time', 
        'customer_note',
        'provider_note',
        'appointment_status'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];


   public function customer(){        
        return $this->belongsTo('App\Models\Customers\Customer', 'customer_id','id');
   }

   public function provider(){        
        return $this->belongsTo('App\Models\Providers\Provider', 'provider_id','id');
   }

   public function no_show_appointment(){        
        return $this->hasOne('App\Models\AppointmentManagement\NoShow', 'appointment_id','id');
   }

//    public function getTimeAttribute ($value) 
//    {
//      //    $timezone = !empty(request()->admin_time_zone) ? request()->admin_time_zone : "America/New_York";
//      //    $dateTime = Carbon::parse($value)->timezone($timezone);
//      //    return date("h:i A", strtotime($dateTime));
//         return $value;
//    }

//    public function getCreatedAtAttribute ($value) 
//    { 
//      //    $timezone = !empty(request()->admin_time_zone) ? request()->admin_time_zone : "America/New_York";
//      //    $dateTime = Carbon::parse($value)->timezone($timezone);
//         return date('m/d/Y h:i A',strtotime($value));
//      //return $value;
//    }

}
