<?php

namespace App\Models\AppointmentManagement;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class NoShow extends Model
{
    protected $table = 'appointment_noshow';

    protected $fillable = [
        'appointment_id', 
        'customer_id', 
        'provider_id', 
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];


   public function customer(){        
        return $this->belongsTo('App\Models\Customers\Customer', 'customer_id','id');
   }

   public function provider(){        
        return $this->belongsTo('App\Models\Providers\Provider', 'provider_id','id');
   }

   public function appointment(){        
        return $this->belongsTo('App\Models\AppointmentManagement\Appointment', 'appointment_id','id');
   }

//    public function getCreatedAtAttribute ($value) 
//    { 
//         $timezone = !empty(request()->admin_time_zone) ? request()->admin_time_zone : "America/New_York";
//         $dateTime = Carbon::parse($value)->timezone($timezone);
//         return date('m/d/Y h:i A',strtotime($dateTime));
//    }

}
