<?php

namespace App\Models\Auth;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;

class Oauth extends Model
{
    use HasFactory, Notifiable;

    protected $table = 'oauth_users';
    public $timestamps = false;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
       'user_id' ,'user_fk', 'role_fk', 'username', 'password', 'first_name', 'last_name', 'email', 'email_verified', 'scope','two_factor_code','two_factor_expires_at'
    ];

    /**
     * The attributes excluded from the model's JSON form.
     *
     * @var array
     */
    protected $hidden = [
        'password',
    ];

    /*public function generateTwoFactorCode()
    {
        $digits = 4;
        $toEmail = $this->email;
        $otpCode = rand(pow(10, $digits-1), pow(10, $digits)-1);

        $data = array('otp'=>$otpCode);
        Mail::send('emails.otp_mail', $data,function($message) use ($toEmail) {
        $message->to($toEmail)
        ->subject('OTP for login');
        $message->from('no-reply@webbycentrall.com','admin');
        }); 
        $this->timestamps = false;
        $this->two_factor_code = $otpCode;
        $this->two_factor_expires_at = strtotime(date("Y-m-d H:i:s"));
        $this->save();
    }*/

    public function provider_time_zone(){        
        return $this->belongsTo('App\Models\Providers\Provider', 'user_fk','id');
    }

    public function customer_time_zone(){        
        return $this->belongsTo('App\Models\Customers\Customer', 'user_fk','id');
    }

}
