<?php

namespace App\Models\Business;

use Illuminate\Database\Eloquent\Model;
use App\Models\Business\BusinessAccessCode;
use Carbon\Carbon;
use App\Models\Business\BusinessDomain;

class Business extends Model
{
    protected $table = 'businesses';

    protected $fillable = [
        'business_name', 
        'business_id', 
        'membership_plan', 
        'access_code_count', 
        'status',
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    public function business_access_code(){
        return $this->belongsToMany('App\Models\Business\BusinessAccessCode','business_id','id');
     }
     public function business_access_code_user_map(){
        return $this->belongsTo('App\Models\Business\BusinessAccessCodeUserMap','business_id','id');
     }

     public function businessDomain(){
        return $this->hasMany(BusinessDomain::class);

     }

 
}
