<?php

namespace App\Models\CMS;

use Illuminate\Database\Eloquent\Model;

class Banner extends Model
{
    protected $fillable = [
        'id',
        'title_en',
        'title_es',
        'type',
        'image', 
        'start_date', 
        'end_date', 
        'create_at', 
        'updated_at',
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    public function getImageAttribute($value) 
    {
        $target = "../storage/banner/".$value;
        
        return image_to_base64($target);
    }
}
