<?php

namespace App\Models\CMS;

use Illuminate\Database\Eloquent\Model;

class FAQ extends Model
{
    protected $table = 'faqs';
    
    protected $fillable = [
        'id', 
        'faqs_type', 
        'question_en', 
        'answer_en',
        'question_es',
        'answer_es'
    ];

    // protected $casts = [
    //     'created_at' => 'datetime:Y-m-d H:i:s',
    //     'updated_at' => 'datetime:Y-m-d H:i:s',
    // ];

    public function getCreatedAtAttribute ($created_at) 
   { 
      return convertTimeUtcToLocal($created_at);
     
   }

   public function getUpdatedAtAttribute ($updated_at) 
   { 
      return convertTimeUtcToLocal($updated_at);
   }

   public function setCreatedAtAttribute () 
   { 
      $this->attributes['created_at']=convertcurrenttimetoUtc(date('Y-m-d H:i:s'));

   }
   
   public function setUpdatedAtAttribute () 
   { 
      $this->attributes['updated_at']=convertcurrenttimetoUtc(date('Y-m-d H:i:s'));
   } 
}
