<?php

namespace App\Models\ChangeProvider;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class ChangeProvider extends Model
{
    protected $table = 'change_provider';

    protected $fillable = [
        'customer_id', 
        'provider_id', 
        'issue_type', 
        'comment', 
    ];

    // protected $casts = [
    //     'created_at' => 'datetime:Y-m-d H:i:s',
    //     'updated_at' => 'datetime:Y-m-d H:i:s',
    // ];

    public function customer(){        
        return $this->belongsTo('App\Models\Customers\Customer', 'customer_id','id');
    }

    public function provider() {  
        return $this->belongsTo('App\Models\Providers\Provider', 'provider_id','id');
    }

    // public function getCreatedAtAttribute ($value) 
    // { 
    //     $timezone = !empty(request()->admin_time_zone) ? request()->admin_time_zone : "America/New_York";
    //     $dateTime = Carbon::parse($value)->timezone($timezone);
    //     return date('m/d/Y h:i A',strtotime($dateTime));
    // }

    public function getCreatedAtAttribute ($created_at) 
   { 
      return convertTimeUtcToLocal($created_at);
     
   }

   public function getUpdatedAtAttribute ($updated_at) 
   { 
      return convertTimeUtcToLocal($updated_at);
   }

   public function setCreatedAtAttribute () 
   { 
      $this->attributes['created_at']=convertcurrenttimetoUtc(date('Y-m-d H:i:s'));

   }
   
   public function setUpdatedAtAttribute () 
   { 
      $this->attributes['updated_at']=convertcurrenttimetoUtc(date('Y-m-d H:i:s'));
   } 
}
