<?php

namespace App\Models\Chat;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;
use App\Models\Providers\Provider;
use App\Models\Customers\Customer;

class AudioVideoCallHistory extends Model
{
    protected $table = 'audio_video_call_history';

    protected $fillable = [
        'appointment_id', 
        'customer_id', 
        'provider_id', 
        'duration', 
        'call_started_at', 
        'call_end_at',
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];
    
    public function customer() {
        return $this->belongsTo(Customer::class, 'customer_id');
    }

    public function provider() {
        return $this->belongsTo(Provider::class, 'provider_id');
    }

}
