<?php

namespace App\Models\Chat;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;
use App\Models\Providers\Provider;
use App\Models\Customers\Customer;
use App\Models\Chat\MessageRoomChat;

class MessageRoom extends Model
{
    protected $table = 'message_rooms';

    protected $fillable = [
        'room_id', 
        'customer_id', 
        'provider_id', 
        'last_message', 
        'last_message_date_time',
        'deleted_by_customer',
        'deleted_by_provider',
    ];


    public function provider() {
        return $this->belongsTo(Provider::class, 'provider_id');
    }

    public function customer() {
        return $this->belongsTo(Customer::class, 'customer_id');
    }

    public function unread_message() {
        return $this->belongsTo(MessageRoomChat::class, 'room_id', 'room_id');
    }
}
