<?php

namespace App\Models\Contractors;

use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Seeder;
use App\Models\Service;
use App\Models\Contractors\Contractor;
use App\Models\Contractors\ServiceCategory;

class ContractorCategory extends Model
{
    protected $table = 'contractor_sub_category';
    protected $primaryKey = 'id';
    protected $fillable = [
        'contractor_id',
        'contractor_service_id',
        'service_cat_id'
    ];

    /**
     * Get the contractor.
     */
    public function contractor() {
        return $this->belongsTo(Contractor::class, 'contractor_id', 'id');
    }

     /**
     * Get the service category.
     */
    public function service_category() {
        return $this->belongsTo(ServiceCategory::class, 'service_cat_id', 'id');
    }

     /**
     * Get the service category.
     */
    public function contractor_service() {
        return $this->belongsTo(ServiceService::class, 'contractor_service_id', 'id');
    }
}
