<?php

namespace App\Models\Customers;

use Illuminate\Database\Eloquent\Model;
use App\Models\Customers\Customer;

class Address extends Model
{
    protected $table = 'customer_addresses';

    protected $fillable = [
        'street_address', 
        'street_name', 
        'apartment_number', 
        'country', 
        'state', 
        'city', 
        'location', 
        'landmark', 
        'pincode', 
        'customer_id',
        'latitude',
        'longitude', 
        'is_default'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    /**
     * Get all the Service & category
     *
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function Customer() {  
        return $this->belongsTo(Customer::class, 'id', 'user_id');
    }

    public function getCreatedAtAttribute ($created_at) 
   { 
      return convertTimeUtcToLocal($created_at);
     
   }

   public function getUpdatedAtAttribute ($updated_at) 
   { 
      return convertTimeUtcToLocal($updated_at);
   }

   public function setCreatedAtAttribute () 
   { 
      $this->attributes['created_at']=convertcurrenttimetoUtc(date('Y-m-d H:i:s'));

   }
   
   public function setUpdatedAtAttribute () 
   { 
      $this->attributes['updated_at']=convertcurrenttimetoUtc(date('Y-m-d H:i:s'));
   } 
}
