<?php

namespace App\Models\Customers;

use Illuminate\Database\Eloquent\Model;
use App\Models\Customers\Appointment;
use App\Models\Providers\Provider;


class AppointmentCancelled extends Model
{
    protected $table = 'appointment_cancelled';
    public $timestamps = false;

    protected $fillable = [
       'id','appointment_id','customer_id','provider_id','cancel_at', 'cancel_reason', 'provider_cancel_request'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];



   public function customer(){        
        return $this->belongsTo('App\Models\Customers\Customer', 'customer_id','id');
   }

   public function provider() {  
        return $this->belongsTo(Provider::class, 'provider_id');
    }

   public function appointment() {  
        return $this->belongsTo(Appointment::class, 'appointment_id');
    }


}
