<?php

namespace App\Models\Customers;

use Illuminate\Database\Eloquent\Model;
use Spatie\Activitylog\Traits\LogsActivity;
use Spatie\Activitylog\LogOptions;


class EmergencyContact extends Model
{
    use LogsActivity;
    protected $table = 'emergency_contacts';

    protected $fillable = [
        'customer_id', 
        'first_name', 
        'last_name', 
        'email', 
        'phone_code', 
        'phone_no', 
        'address', 
        'relationship',
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    public function getActivitylogOptions(): LogOptions
    {
        return LogOptions::defaults()
        ->useLogName('Customer Emergency Contact Information')
        ->logOnlyDirty()
        ->logOnly(['first_name','last_name','email','password','phone_no','address','relationship'])
        ->setDescriptionForEvent(fn(string $eventName) => "This emergency contact information has been {$eventName}");
    }

}
