<?php

namespace App\Models\Customers;

use Illuminate\Database\Eloquent\Model;


class RescheduleAppointment extends Model
{
    protected $table = 'reschedule_appointments';

    protected $fillable = [
        'appointment_id ', 
        'customer_id', 
        'provider_id', 
        'date', 
        'day', 
        'time', 
        'customer_note',
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];



   public function customer(){        
        return $this->belongsTo('App\Models\Customers\Customer', 'customer_id','id');
   }

   public function provider(){        
        return $this->belongsTo('App\Models\Providers\Provider', 'provider_id','id');
   }

   public function setDateAttribute ($value) 
   {
       $this->attributes['date'] = dateFormat($value);
   }

}
