<?php

namespace App\Models\Customers;

use Illuminate\Database\Eloquent\Model;

use App\Models\Customers\Customer;
use App\Models\Customers\Contractor;

class Review extends Model
{
    protected $table = 'user_review';

    protected $fillable = [
        'user_id',
        'contractor_id',
        'rating',
        'review'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    public function user() {
        
        return $this->belongsTo(Customer::class, 'user_id');
    }

    public function contractor() {
        
        return $this->belongsTo(Contractor::class, 'contractor_id');
    }
}
