<?php

namespace App\Models\Groups;

use Illuminate\Database\Eloquent\Model;

class Group extends Model
{
    protected $fillable = [ 
       'name',
       'user_id'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];
    
    public function user() {
        return $this->belongsTo('App\Models\Customers\Customer')->select('id','first_name','last_name','email','phone_code','phone');
    }

    public function members() {
        return $this->hasMany('App\Models\Groups\GroupMember');
    }


}
