<?php

namespace App\Models\Journals;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;

class Journal extends Model
{
    protected $table = 'journals';

    protected $fillable = [
        'provider_id', 
        'date', 
        'customer_id', 
        'title', 
        'comment',
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    public function getDateAttribute ($value) 
    {
        return showDateFormat($value);
    }

    public function setDateAttribute ($value) 
    {
        $this->attributes['date'] = dateFormat($value);
    }
}
