<?php

namespace App\Models\Products;

use Illuminate\Database\Eloquent\Model;

class ProductImage extends Model
{
    protected $fillable = [    
        'product_id', 
        'variant_id',
        'image'
    ];

    protected $appends = [
        'small',
        'medium',
        'large',
        'original'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    protected $hidden = [
         'image',
         'created_at', 
         'updated_at'
    ];

    public function getSmallAttribute()
    {
        $value = $this->getAttributeValue('image');
         //return url('/storage/product/thumb/small') . '/' . $value;
        $target = "../storage/product/thumb/small/".$value;
        return image_to_base64($target);
    }

    public function getMediumAttribute()
    {
        $value = $this->getAttributeValue('image');
        // return url('/storage/product/thumb/medium') . '/' . $value;
        $target = "../storage/product/thumb/medium/".$value;
        return image_to_base64($target);
    }

    public function getLargeAttribute()
    {
        $value = $this->getAttributeValue('image');
     //return url('/storage/product/thumb/large') . '/' . $value;
        $target = "../storage/product/thumb/large/".$value;
        return image_to_base64($target);
    }

    public function getOriginalAttribute()
    {
        $value = $this->getAttributeValue('image');
        //return url('/storage/product') . '/' . $value;
        $target = "../storage/product/".$value;
        return image_to_base64($target);
    }

}
