<?php

namespace App\Models\Products;

use Illuminate\Database\Eloquent\Model;

class ProductVariant extends Model
{
    protected $fillable = [    
        'product_id', 
        'size_id',
        'color_id',
        'quantity',
        'price',
        'default',
        'final_price'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    public function colors() 
    {
        return $this->belongsTo('App\Models\Colors\Color','color_id');
    }

    public function sizes() 
    {
        return $this->belongsTo('App\Models\Sizes\Size','size_id');
    }

    public function variant_images() {
        return $this->belongsTo('App\Models\Products\ProductImage','id','variant_id');
    }


}
