<?php

namespace App\Models\Providers;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;
use App\Models\Providers\Provider;
use App\Models\Customers\Customer;
use App\Models\Providers\MessageRoomChat;

class ProviderSlot extends Model
{
    protected $table = 'provider_slots';

    protected $fillable = [
        'provider_id', 
        'availability_id',
        'day', 
        'slot',
        'type',
    ];


    public function provider() {
        return $this->belongsTo(Provider::class, 'provider_id');
    }

    public function customer() {
        return $this->belongsTo(Customer::class, 'customer_id');
    }
}
