<?php

namespace App\Models\Providers;

use Illuminate\Database\Eloquent\Model;
use Carbon\Carbon;


class ProviderTimeOff extends Model
{
    protected $table = 'provider_time_off';

    protected $fillable = [
        'provider_id ', 
        'reason', 
        'start_date', 
        'start_time', 
        'end_date', 
        'end_time', 
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

   public function getStartTimeAttribute ($value) 
   {
        // $timezone = request()->time_zone;
        // $dateTime = Carbon::parse($value)->timezone($timezone);
        // return date("h:i A", strtotime($dateTime));
        return date("h:i A", strtotime($value));
   }

   public function getEndTimeAttribute ($value) 
   {
        // $timezone = request()->time_zone;
        // $dateTime = Carbon::parse($value)->timezone($timezone);
        // return date("h:i A", strtotime($dateTime));
        return date("h:i A", strtotime($value));
   }

   public function getStartDateAttribute ($value) 
   {
       return showDateFormat($value);
   }

   public function getEndDateAttribute ($value) 
   {
       return showDateFormat($value);
   }

}
