<?php

namespace App\Models\Roles;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Notifications\Notifiable;
use Spatie\Activitylog\Traits\LogsActivity;
use Spatie\Activitylog\LogOptions;
use Carbon\Carbon;

class Role extends Model
{
    use HasFactory, Notifiable,LogsActivity;

    protected $table = 'roles';
    public $timestamps = false;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */
    protected $fillable = [
        'name', 'description', 'status', 'scope', 'read_only','is_deleted'
    ];

    /**
     * The attributes excluded from the model's JSON form.
     *
     * @var array
     */
    
    public function countUser(){        
        return $this->hasOne('App\Models\Users\Oauth', 'role_fk','id');
    }

    // Customize log description
    public function getActivitylogOptions(): LogOptions
    {
        return LogOptions::defaults()
        ->useLogName('Role')
        ->logOnlyDirty()
        ->logOnly(['name', 'description','status','scope','read_only'])
        ->setDescriptionForEvent(fn(string $eventName) => "This role has been {$eventName}");
    }

   public function getCreatedAtAttribute ($value) 
   { 
        // $timezone = !empty(request()->admin_time_zone) ? request()->admin_time_zone : "America/New_York";
        // $dateTime = Carbon::parse($value)->timezone($timezone);
        // return date('m/d/Y h:i A',strtotime($dateTime));
        return $value; 
   }
}
