<?php

namespace App\Models\Vendors;

use Illuminate\Database\Eloquent\Model;
use App\Models\Vendors\Vendor;

class Address extends Model
{
    protected $table = 'vendor_addresses';

    protected $fillable = [
        'street_address', 
        'street_name', 
        'apartment_number', 
        'country', 
        'state',
        'city', 
        'location', 
        'landmark',
        'pincode', 
        'vendor_id', 
        'is_default'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    /**
     * Get all the Service & category
     *
     * @return \Illuminate\Database\Eloquent\Relations\HasMany
     */
    public function Vendor() {
        
        return $this->belongsTo(Vendor::class, 'id', 'user_id');
    }
}
