<?php

namespace App\Models\Vendors;

use Illuminate\Database\Eloquent\Model;

class ReviewAndRating extends Model
{
    protected $table = 'user_review';
    
    protected $fillable = [
        
        'user_id', 
        'contractor_id', 
        'rating', 
        'review'
    ];

    protected $casts = [
        'created_at' => 'datetime:Y-m-d H:i:s',
        'updated_at' => 'datetime:Y-m-d H:i:s',
    ];

    public function contractor() {
        
        return $this->belongsTo(Vendor::class, 'contractor_id');
    }

    public function user(){
        
    	return $this->belongsTo(Vendor::class, 'user_id');
    }
}
