<?php

namespace App\Notifications;

use Illuminate\Bus\Queueable;
use Illuminate\Contracts\Queue\ShouldQueue;
use Illuminate\Notifications\Notification as NotificationsNotification;
// use Illuminate\Notifications\Messages\MailMessage;

class JobsNotification extends NotificationsNotification
{
    use Queueable;
    private $details;
    private $role;
    /**
     * Create a new notification instance.
     *
     * @return void
     */
    public function __construct($role, $details)
    {
        $this->details = $details;
        $this->role = $role;

        // echo "<pre>"; print_r($this->role); die;
    }

    /**
     * Get the notification's delivery channels.
     *
     * @param mixed $notifiable
     * @return array
     */
    public function via($notifiable)
    {
        return ['database'];
        // return ['mail', 'database'];
    }

    /**
     * Get the mail representation of the notification.
     *
     * @param mixed $notifiable
     * @return \Illuminate\Notifications\Messages\MailMessage
     */
    public function toMail($notifiable)
    {
        // return (new MailMessage)
        //             ->greeting($this->details['greeting'])
        //             ->line($this->details['body'])
        //             ->line($this->details['thanks'])
        //             ->line("Please login to application using your login credentials.")
        //             ->line("Warm Regards")
        //             ->line("Team ZION");
    }

    /**
     * Get the array representation of the notification.
     *
     * @param mixed $notifiable
     * @return array
     */
    // public function toArray($notifiable)
    // {
    //     return [
    //         'id' => $this->id,
    //         'user_type' => $this->role,
    //         'data' => $this->details
    //     ];
    // }

    public function toDatabase($notifiable)
    {
        return [
            'id' => $this->id,
            'user_type' => $this->role,
            'data' => $this->details
        ];
    }
}
