<?php

namespace App\Providers;

use Illuminate\Support\ServiceProvider;
use Illuminate\Support\Facades\Route;
// use Illuminate\Foundation\Support\Providers\RouteServiceProvider as ServiceProvider;

class RouteServiceProvider extends ServiceProvider
{
    /**
     * This namespace is applied to your controller routes.
     *
     * In addition, it is set as the URL generator's root namespace.
     *
     * @var string
     */
    protected $namespace = 'App\Http\Controllers';

    /**
     * Define your route model bindings, pattern filters, etc.
     *
     * @return void
     */
    public function boot() {
        //
        // parent::boot();
    }

    public function register() {
        $this->map();
     }

    /**
     * Define the routes for the application.
     *
     * @return void
     */
    public function map()
    {
        $this->mapWebRoutes();
        $this->mapOauthApiRoutes();
        $this->mapUserApiRoutes();
    }

    /**
     * Define the "web" routes for the application.
     *
     * These routes all receive session state, CSRF protection, etc.
     *
     * @return void
     */
    protected function mapWebRoutes()
    {
        Route::group([
            'middleware' => 'web',
            'namespace' => $this->namespace,
        ], function ($router) {
            require base_path('routes/web.php');
        });
    }

    protected function mapOauthApiRoutes() {
        Route::group([
            'namespace' => $this->namespace,
            'prefix' => 'api/v2',
        ], function ($router) {
            require base_path('routes/auth.php');
        });
    }

    protected function mapUserApiRoutes() {
        Route::group([
            'namespace' => $this->namespace,
            'prefix' => 'api/v2',
        ], function ($router) {
            require base_path('routes/users.php');
        });
    }
}
