<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */

// brands api
$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "Business";
    $router->post('business/store', ['as' => 'business', 'uses' => $path . '\BusinessController@store']);
    $router->get('business/list', ['as' => 'business', 'uses' => $path . '\BusinessController@index']);
    $router->post('business/check-domain', ['as' => 'business', 'uses' => $path . '\BusinessController@checkDomain']);    
    $router->get('business/get-business-list', ['as' => 'business', 'uses' => $path.'\BusinessController@getBusinessList']);
    $router->get('business/getAccessCode/{id}',['as' => 'business', 'uses' => $path.'\BusinessController@geAccessCodeList']);
    //Mobile Request     
    $router->post('business/request-access-code', ['as' => 'business', 'uses' => $path.'\BusinessController@requestAccessCode']);
    $router->delete('/business/access_code/delete/{id}',['as'=>'business','uses'=>$path.'\BusinessController@accessCodeDelete']);
    $router->delete('/business/multiple_access_code/delete/{id}',['as'=>'business','uses'=>$path.'\BusinessController@multipleAccessCodeDelete']);
    $router->get('/business/getBusinessDetails/{id}' ,['as'=>'business','uses'=>$path.'\BusinessController@getBusinessDetails']);
    $router->get('/business/export',['as'=>'business','uses'=>$path.'\BusinessController@export']);
    $router->post('/business/update-business',['as'=>'business','uses'=>$path.'\BusinessController@update']);
    $router->get('business/access_code/remove/{id}',['as'=>'business','uses'=>$path.'\BusinessController@accessCodeRemove']);
    $router->delete('business/multiple_access_code/remove/{id}',['as'=>'business','uses'=>$path.'\BusinessController@multipuleAccessCodeRemove']);
    $router->get('business/export-access-code-data/{id}',['as'=>'business','uses'=>$path.'\BusinessController@exportAccessCodeData']); 
    $router->post('business/export-pdf/{id}',['as'=>'business','uses'=>$path.'\BusinessController@exportPdf']); 
    $router->post('business/export-pdf-insert',['as'=>'business','uses'=>$path.'\BusinessController@exportPdfInsert']); 
    $router->get('business/get-last-pdf/{id}',['as'=>'business','uses'=>$path.'\BusinessController@getLastPdf']); 
    
  });

?>