<?php

/* 
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */


// Customers API
$router->group(['prefix' => 'api/v2/', 'middleware' => 'language'], function () use ($router) {
    
    $path = "Customers";
    
    // webhook for recurring payment
    $router->post('customers/subscription-recurring-payment', ['as' => 'users', 'uses' => $path.'\CustomerController@subscriptionRecurringPayment']);

    $router->get('customers/race-list', ['as' => 'users', 'uses' => $path . '\CustomerController@raceList']);

    $router->get('customers/ethnicity-list', ['as' => 'users', 'uses' => $path . '\CustomerController@ethnicityList']);

    $router->get('customers/religious-list', ['as' => 'users', 'uses' => $path . '\CustomerController@religiousList']);

    $router->get('customers/relationship-list', ['as' => 'users', 'uses' => $path . '\CustomerController@relationshipList']);

    $router->post('customer-check-email-phone-exist', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCheckEmailPhoneExist']);

    $router->post('customers/register-step-1-2', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep1And2']);

    $router->post('customer-verify-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@verifyTwoFactor']);

    $router->get('customers/intake-question-options', ['as' => 'users', 'uses' => $path . '\CustomerController@intakeQuestionOptions']);

    $router->post('customer-forgot-password-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@forgotPasswordOtp']);

    $router->post('customer-verify-forgot-password-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@verifyForgotPasswordOtp']);

    $router->post('customer-forgot-password', ['as' => 'users', 'uses' => $path.'\CustomerController@forgotPassword']);

    $router->post('customers/confirm-email', ['as' => 'providers', 'uses' => $path . '\CustomerController@customerConfirmEmail']);

    
    $router->group(['middleware' => 'auth'], function () use ($router, $path) {
        
        
        $router->post('customer-set-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSetPin']);        

        $router->post('customer-change-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerChangePin']);

        $router->post('customer-reset-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerResetPin']);

        $router->post('customer-match-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerMatchPin']);
        // my route
        $router->post('customers/register-step-3', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep3']);

        $router->post('customers/register-step-4', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep4']);

        $router->post('customer-change-password', ['as' => 'users', 'uses' => $path.'\CustomerController@changePassword']);

        $router->get('customer-my-profile', ['as' => 'users', 'uses' => $path.'\CustomerController@profile']);

        $router->post('customers/update-profile', ['as' => 'users', 'uses' => $path.'\CustomerController@updateCustomerProfile']);

        
        $router->get('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProviders']);

        $router->post('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv2']);

        
        /*$router->get('customer-recommended-providers-list', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedProvidersList']);

        $router->get('customer-other-providers-list', ['as' => 'users', 'uses' => $path.'\CustomerController@otherProvidersList']);*/

        $router->post('customers/search-provider-list', ['as' => 'users', 'uses' => $path.'\CustomerController@searchProviderList']);

        $router->post('customer-book-session', ['as' => 'users', 'uses' => $path.'\CustomerController@bookSessionV3']);
        
        $router->get('provier-full-profile/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@providerFullProfile']);


        $router->post('customer-add-appointment', ['as' => 'users', 'uses' => $path.'\CustomerController@customerAddAppointment']);

        $router->post('customers/my-appointments', ['as' => 'users', 'uses' => $path.'\CustomerController@customerMyAppointments']);

        $router->post('customer-reschedule-appointment', ['as' => 'users', 'uses' => $path . '\CustomerController@customerRescheduleAppointment']);

        $router->post('customer-cancel-appointment', ['as' => 'users', 'uses' => $path . '\CustomerController@customerCancelAppointment']);

        $router->get('customers/session-detail/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSessionDetail']);

        $router->post('customer-update-emergency-contact', ['as' => 'users', 'uses' => $path.'\CustomerController@customerUpdateEmergencyContact']);

        $router->get('customers/home-page', ['as' => 'users', 'uses' => $path.'\CustomerController@customerHomePagev2']);

        // $router->get('customers/home-page', ['as' => 'users', 'uses' => $path.'\CustomerController@customerHomePage']);

        $router->post('customer-change-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@customerChangeProvider']);

        $router->get('customer-journal-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalList']);

        $router->post('customer-journal-create', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalCreate']);

        $router->post('customer-journal-update', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalUpdate']);
        
        $router->delete('customer-journal-delete/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@customerJournalDelete']);

        $router->get('customer-view-journal/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalView']);

        $router->post('customers/payment-history', ['as' => 'users', 'uses' => $path.'\CustomerController@customerPaymentHistory']);

        $router->get('customer-chat-room', ['as' => 'providers', 'uses' => $path.'\CustomerController@customerChatRoom']);

        $router->get('customer-chat/{id}/messages', ['as' => 'chat', 'uses' => $path.'\CustomerController@getMessageById']); 

        $router->post('customer-send-message', ['as' => 'providers', 'uses' => $path.'\CustomerController@sendMessageById']); 

        $router->get('customer-audio-video-session-list', ['as' => 'chat', 'uses' => $path.'\CustomerController@customerAudioVideoSessionList']);

        $router->post('customer-rating-review-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRatingReviewToProvider']);

        $router->get('customer-notifications', ['as' => 'chat', 'uses' => $path.'\CustomerController@customerNotifications']);

        $router->post('customer-notification-setting', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNotificationSetting']);

        $router->get('customer-notification-setting-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNotificationSettingList']);

        $router->get('customers/intake-question-answer-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerIntakeQuestionAnswerList']);

        $router->post('customers/update-intake-question', ['as' => 'users', 'uses' => $path.'\CustomerController@customerUpdateIntakeQuestion']);

        $router->get('customers/current-active-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCurrentActivePlan']);
        $router->get('customer-subscription-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSubscriptionPlan']);

        $router->get('customer-other-plan-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerOtherPlanList']);

        $router->post('customers/subscription-payment', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSubscriptionPayment']);

        $router->put('customer-cancel-subscription-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCancelSubscriptionPlan']);

        $router->post('customers/two-factor-enable-disable', ['as' => 'users', 'uses' => $path.'\CustomerController@customerTwoFactorEnableDisable']); 

        $router->post('customers/session-token', ['as' => 'users', 'uses' => $path.'\CustomerController@sessionToken']); 
        $router->post('customers/join-session', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJoinSession']); 
        $router->post('customers/save-video-session-detail', ['as' => 'providers', 'uses' => $path.'\CustomerController@customerSaveVideoSessionDetail']); 
        
        $router->get('customers/no-show-time', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNoShowTime']); 

        $router->post('customers/notification-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@noShowNotificationToProvider']); 

        $router->post('customers/session-did-not-join-notification-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@sessionDidNotJoinNotificationToProvider']); 

        $router->put('customers/change-language', ['as' => 'users', 'uses' => $path.'\CustomerController@changeLanguage']);

        $router->post('customers/delete-customer-account', ['as' => 'users', 'uses' => $path.'\CustomerController@deleteCustomerAccount']); 

        $router->get('customers', ['as' => 'users', 'uses' => $path.'\CustomerController@index']);
        $router->get('archived/customers', ['as' => 'users', 'uses' => $path.'\CustomerController@archivedCustomers']);
        $router->get('customers/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@show']);
        $router->delete('customers/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@archiveCustomer']);

        $router->delete('customers/delete/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@deleteCustomer']);

        $router->put('customers/{id}/active-inactive', ['as' => 'users', 'uses' => $path . '\CustomerController@activeInactive']);

        $router->put('customers/unarchive/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@unarchiveCustomer']);

        $router->put('customers/unblock/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@unblockCustomer']);

        $router->post('customers/update/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@updateCustomer']);

        // dashboard 
            $router->get('customers-count', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCount']);
        //

        // end my route
        



        //$router->get('customers/search', ['as' => 'users', 'uses' => $path.'\CustomerController@index']);
        //$router->get('customers/myinfo', ['as' => 'users', 'uses' => $path.'\CustomerController@showMyInfo']);
        $router->post('customers/{id}/reset_password', ['as' => 'vendors', 'uses' => $path . '\CustomerController@resetPassword']);
        $router->put('customer/{id}/active_inactive', ['as' => 'vendors', 'uses' => $path . '\CustomerController@activeInactive']);
        $router->get('customer/{id}/profile_picture', ['as' => 'users', 'uses' => $path . '\CustomerController@viewAvatar']);

        // my jobs
        $router->get('customers/{id}/jobs', ['as' => 'jobs', 'uses' => $path.'\JobsController@allCustomerJobs']);
        
        $router->post('customers/update-remaining-appointment', ['as' => 'vendors', 'uses' => $path . '\CustomerController@update_remaining_appointment_consumer']);
    });
});


//**** Subcodevs v3 api ******/
// Customers API
$router->group(['prefix' => 'api/v3/', 'middleware' => 'language'], function () use ($router) {
    
    $path = "v3\Customers";
    
    // webhook for recurring payment
    $router->post('customers/subscription-recurring-payment', ['as' => 'users', 'uses' => $path.'\CustomerController@subscriptionRecurringPayment']);

    $router->get('customers/race-list', ['as' => 'users', 'uses' => $path . '\CustomerController@raceList']);

    $router->get('customers/ethnicity-list', ['as' => 'users', 'uses' => $path . '\CustomerController@ethnicityList']);

    $router->get('customers/religious-list', ['as' => 'users', 'uses' => $path . '\CustomerController@religiousList']);

    $router->get('customers/relationship-list', ['as' => 'users', 'uses' => $path . '\CustomerController@relationshipList']);

    $router->post('customer-check-email-phone-exist', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCheckEmailPhoneExist']);

    $router->post('customers/register-step-1-2', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep1And2']);

    $router->post('customer-verify-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@verifyTwoFactor']);

    $router->get('customers/intake-question-options', ['as' => 'users', 'uses' => $path . '\CustomerController@intakeQuestionOptions']);

    $router->post('customer-forgot-password-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@forgotPasswordOtp']);

    $router->post('customer-verify-forgot-password-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@verifyForgotPasswordOtp']);

    $router->post('customer-forgot-password', ['as' => 'users', 'uses' => $path.'\CustomerController@forgotPassword']);

    $router->post('customers/confirm-email', ['as' => 'providers', 'uses' => $path . '\CustomerController@customerConfirmEmail']);

    
    $router->group(['middleware' => 'auth'], function () use ($router, $path) {
        
        
        $router->post('customer-set-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSetPin']);        

        $router->post('customer-change-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerChangePin']);

        $router->post('customer-reset-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerResetPin']);

        $router->post('customer-match-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerMatchPin']);
        // my route
        $router->post('customers/register-step-3', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep3']);

        $router->post('customers/register-step-4', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep4']);

        $router->post('customer-change-password', ['as' => 'users', 'uses' => $path.'\CustomerController@changePassword']);

        $router->get('customer-my-profile', ['as' => 'users', 'uses' => $path.'\CustomerController@profile']);

        $router->post('customers/update-profile', ['as' => 'users', 'uses' => $path.'\CustomerController@updateCustomerProfile']);

        
        $router->get('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv2']);
        $router->post('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv3']);
        $router->get('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv2']);

        // $router->post('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv2']);

        
        /*$router->get('customer-recommended-providers-list', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedProvidersList']);

        $router->get('customer-other-providers-list', ['as' => 'users', 'uses' => $path.'\CustomerController@otherProvidersList']);*/

        $router->post('customers/search-provider-list', ['as' => 'users', 'uses' => $path.'\CustomerController@searchProviderList']);

        //$router->post('customer-book-session', ['as' => 'users', 'uses' => $path.'\CustomerController@bookSessionV3']);
        $router->post('customer-book-session', ['as' => 'users', 'uses' => $path.'\CustomerController@bookSessionV3_sd']);
        
        $router->get('provier-full-profile/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@providerFullProfile']);


        $router->post('customer-add-appointment', ['as' => 'users', 'uses' => $path.'\CustomerController@customerAddAppointment']);

        $router->post('customers/my-appointments', ['as' => 'users', 'uses' => $path.'\CustomerController@customerMyAppointments']);

        $router->post('customer-reschedule-appointment', ['as' => 'users', 'uses' => $path . '\CustomerController@customerRescheduleAppointment']);

        $router->post('customer-cancel-appointment', ['as' => 'users', 'uses' => $path . '\CustomerController@customerCancelAppointment']);

        $router->get('customers/session-detail/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSessionDetail']);

        $router->post('customer-update-emergency-contact', ['as' => 'users', 'uses' => $path.'\CustomerController@customerUpdateEmergencyContact']);

        $router->post('customers/home-page', ['as' => 'users', 'uses' => $path.'\CustomerController@customerHomePagev2']);

       $router->get('customers/home-page', ['as' => 'users', 'uses' => $path.'\CustomerController@customerHomePage']);

        $router->post('customer-change-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@customerChangeProvider']);

        $router->get('customer-journal-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalList']);

        $router->post('customer-journal-create', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalCreate']);

        $router->post('customer-journal-update', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalUpdate']);
        
        $router->delete('customer-journal-delete/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@customerJournalDelete']);

        $router->get('customer-view-journal/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalView']);

        $router->post('customers/payment-history', ['as' => 'users', 'uses' => $path.'\CustomerController@customerPaymentHistory']);

        $router->get('customer-chat-room', ['as' => 'providers', 'uses' => $path.'\CustomerController@customerChatRoom']);

        $router->get('customer-chat/{id}/messages', ['as' => 'chat', 'uses' => $path.'\CustomerController@getMessageById']); 

        $router->post('customer-send-message', ['as' => 'providers', 'uses' => $path.'\CustomerController@sendMessageById']); 

        $router->get('customer-audio-video-session-list', ['as' => 'chat', 'uses' => $path.'\CustomerController@customerAudioVideoSessionList']);

        $router->post('customer-rating-review-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRatingReviewToProvider']);

        $router->get('customer-notifications', ['as' => 'chat', 'uses' => $path.'\CustomerController@customerNotifications']);

        $router->post('customer-notification-setting', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNotificationSetting']);

        $router->get('customer-notification-setting-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNotificationSettingList']);

        $router->get('customers/intake-question-answer-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerIntakeQuestionAnswerList']);

        $router->post('customers/update-intake-question', ['as' => 'users', 'uses' => $path.'\CustomerController@customerUpdateIntakeQuestion']);

        $router->get('customers/current-active-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCurrentActivePlan']);
        $router->get('customer-subscription-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSubscriptionPlan']);

        $router->get('customer-other-plan-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerOtherPlanList']);

        $router->post('customers/subscription-payment', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSubscriptionPayment']);

        $router->put('customer-cancel-subscription-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCancelSubscriptionPlan']);

        $router->post('customers/two-factor-enable-disable', ['as' => 'users', 'uses' => $path.'\CustomerController@customerTwoFactorEnableDisable']); 

        $router->post('customers/session-token', ['as' => 'users', 'uses' => $path.'\CustomerController@sessionToken']); 
        $router->post('customers/join-session', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJoinSession']); 
        $router->post('customers/save-video-session-detail', ['as' => 'providers', 'uses' => $path.'\CustomerController@customerSaveVideoSessionDetail']); 
        
        $router->get('customers/no-show-time', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNoShowTime']); 

        $router->post('customers/notification-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@noShowNotificationToProvider']); 

        $router->post('customers/session-did-not-join-notification-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@sessionDidNotJoinNotificationToProvider']); 

        $router->put('customers/change-language', ['as' => 'users', 'uses' => $path.'\CustomerController@changeLanguage']);

        $router->post('customers/delete-customer-account', ['as' => 'users', 'uses' => $path.'\CustomerController@deleteCustomerAccount']); 

        $router->get('customers', ['as' => 'users', 'uses' => $path.'\CustomerController@index']);
        $router->get('archived/customers', ['as' => 'users', 'uses' => $path.'\CustomerController@archivedCustomers']);
        $router->get('customers/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@show']);
        $router->delete('customers/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@archiveCustomer']);

        $router->delete('customers/delete/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@deleteCustomer']);

        $router->put('customers/{id}/active-inactive', ['as' => 'users', 'uses' => $path . '\CustomerController@activeInactive']);

        $router->put('customers/unarchive/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@unarchiveCustomer']);

        $router->put('customers/unblock/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@unblockCustomer']);

        $router->post('customers/update/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@updateCustomer']);

        // dashboard 
            $router->get('customers-count', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCount']);
        //

        // end my route
        



        //$router->get('customers/search', ['as' => 'users', 'uses' => $path.'\CustomerController@index']);
        //$router->get('customers/myinfo', ['as' => 'users', 'uses' => $path.'\CustomerController@showMyInfo']);
        $router->post('customers/{id}/reset_password', ['as' => 'vendors', 'uses' => $path . '\CustomerController@resetPassword']);
        $router->put('customer/{id}/active_inactive', ['as' => 'vendors', 'uses' => $path . '\CustomerController@activeInactive']);
        $router->get('customer/{id}/profile_picture', ['as' => 'users', 'uses' => $path . '\CustomerController@viewAvatar']);

        // my jobs
        $router->get('customers/{id}/jobs', ['as' => 'jobs', 'uses' => $path.'\JobsController@allCustomerJobs']);
        
        $router->post('customers/update-remaining-appointment', ['as' => 'vendors', 'uses' => $path . '\CustomerController@update_remaining_appointment_consumer']);
    });
});



//**** Subcodevs v4 api ******/
// Customers API
$router->group(['prefix' => 'api/v4/', 'middleware' => 'language'], function () use ($router) {
    
    $path = "v4\Customers";
    
    $router->get('customers/multiple-plan-list', ['as' => 'users', 'uses' => $path . '\CustomerController@planList']);
    $router->get('customers/multiple-plan-list-admin', ['as' => 'users', 'uses' => $path . '\CustomerController@planListAdmin']);
    // webhook for recurring payment
    $router->post('customers/subscription-recurring-payment', ['as' => 'users', 'uses' => $path.'\CustomerController@subscriptionRecurringPayment']);

    $router->get('customers/race-list', ['as' => 'users', 'uses' => $path . '\CustomerController@raceList']);

    $router->get('customers/ethnicity-list', ['as' => 'users', 'uses' => $path . '\CustomerController@ethnicityList']);

    $router->get('customers/religious-list', ['as' => 'users', 'uses' => $path . '\CustomerController@religiousList']);

    $router->get('customers/relationship-list', ['as' => 'users', 'uses' => $path . '\CustomerController@relationshipList']);

    $router->post('customer-check-email-phone-exist', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCheckEmailPhoneExist']);

    $router->post('customers/register-step-1-2', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep1And2']);
    $router->post('customers/signup', ['as' => 'users', 'uses' => $path.'\CustomerController@signup']);
    $router->post('customers/emailverify', ['as' => 'users', 'uses' => $path.'\CustomerController@emailverify']);
  
    $router->post('customers/sendverifymail', ['as' => 'users', 'uses' => $path.'\CustomerController@sendverifymail']);

    $router->post('customer-verify-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@verifyTwoFactor']);

    $router->get('customers/intake-question-options', ['as' => 'users', 'uses' => $path . '\CustomerController@intakeQuestionOptions']);

    $router->post('customer-forgot-password-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@forgotPasswordOtp']);

    $router->post('customer-verify-forgot-password-otp', ['as' => 'users', 'uses' => $path.'\CustomerController@verifyForgotPasswordOtp']);

    $router->post('customer-forgot-password', ['as' => 'users', 'uses' => $path.'\CustomerController@forgotPassword']);

    $router->post('customers/confirm-email', ['as' => 'providers', 'uses' => $path . '\CustomerController@customerConfirmEmail']);

    $router->post('customers/send-otp', ['as' => 'users', 'uses' => $path . '\CustomerController@sendOTP']);
    
    $router->group(['middleware' => 'auth'], function () use ($router, $path) {
        
        $router->post('customers/register-step-1',['as' => 'users', 'uses' => $path.'\CustomerController@register_step_1']);
        $router->post('customers/register-step-2',['as' => 'users', 'uses' => $path.'\CustomerController@register_step_2']);
        
        $router->post('customer-set-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSetPin']);        

        $router->post('customer-change-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerChangePin']);

        $router->post('customer-reset-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerResetPin']);

        $router->post('customer-match-pin', ['as' => 'users', 'uses' => $path.'\CustomerController@customerMatchPin']);
        // my route
        $router->post('customers/register-step-3', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep3']);

        $router->post('customers/register-step-4', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRegisterStep4']);

        $router->post('customer-change-password', ['as' => 'users', 'uses' => $path.'\CustomerController@changePassword']);

        $router->get('customer-my-profile', ['as' => 'users', 'uses' => $path.'\CustomerController@profile']);

        $router->post('customers/update-profile', ['as' => 'users', 'uses' => $path.'\CustomerController@updateCustomerProfile']);

        
        $router->get('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv2']);
        $router->post('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv3']);
       // $router->get('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv2']);

        // $router->post('customer-recommended-with-other-providers', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedWithOtherProvidersv2']);

        
        /*$router->get('customer-recommended-providers-list', ['as' => 'users', 'uses' => $path.'\CustomerController@recommendedProvidersList']);

        $router->get('customer-other-providers-list', ['as' => 'users', 'uses' => $path.'\CustomerController@otherProvidersList']);*/

        $router->post('customers/search-provider-list', ['as' => 'users', 'uses' => $path.'\CustomerController@searchProviderList']);

        //$router->post('customer-book-session', ['as' => 'users', 'uses' => $path.'\CustomerController@bookSessionv4']);
        $router->post('customer-book-session', ['as' => 'users', 'uses' => $path.'\CustomerController@bookSessionv3_sd']);
        
        $router->get('provier-full-profile/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@providerFullProfile']);


        $router->post('customer-add-appointment', ['as' => 'users', 'uses' => $path.'\CustomerController@customerAddAppointment']);

        $router->post('customers/my-appointments', ['as' => 'users', 'uses' => $path.'\CustomerController@customerMyAppointments']);

        $router->post('customer-reschedule-appointment', ['as' => 'users', 'uses' => $path . '\CustomerController@customerRescheduleAppointment']);

        $router->post('customer-cancel-appointment', ['as' => 'users', 'uses' => $path . '\CustomerController@customerCancelAppointment']);

        $router->get('customers/session-detail/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSessionDetail']);

        $router->post('customer-update-emergency-contact', ['as' => 'users', 'uses' => $path.'\CustomerController@customerUpdateEmergencyContact']);

        $router->post('customers/home-page', ['as' => 'users', 'uses' => $path.'\CustomerController@customerHomePagev2']);

       $router->get('customers/home-page', ['as' => 'users', 'uses' => $path.'\CustomerController@customerHomePage']);

        $router->post('customer-change-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@customerChangeProvider']);

        $router->get('customer-journal-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalList']);

        $router->post('customer-journal-create', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalCreate']);

        $router->post('customer-journal-update', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalUpdate']);
        
        $router->delete('customer-journal-delete/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@customerJournalDelete']);

        $router->get('customer-view-journal/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJournalView']);

        $router->post('customers/payment-history', ['as' => 'users', 'uses' => $path.'\CustomerController@customerPaymentHistory']);

        $router->get('customer-chat-room', ['as' => 'providers', 'uses' => $path.'\CustomerController@customerChatRoom']);

        $router->get('customer-chat/{id}/messages', ['as' => 'chat', 'uses' => $path.'\CustomerController@getMessageById']); 

        $router->post('customer-send-message', ['as' => 'providers', 'uses' => $path.'\CustomerController@sendMessageById']); 

        $router->get('customer-audio-video-session-list', ['as' => 'chat', 'uses' => $path.'\CustomerController@customerAudioVideoSessionList']);

        $router->post('customer-rating-review-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@customerRatingReviewToProvider']);

        $router->get('customer-notifications', ['as' => 'chat', 'uses' => $path.'\CustomerController@customerNotifications']);

        $router->post('customer-notification-setting', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNotificationSetting']);

        $router->get('customer-notification-setting-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNotificationSettingList']);

        $router->get('customers/intake-question-answer-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerIntakeQuestionAnswerList']);

        $router->post('customers/update-intake-question', ['as' => 'users', 'uses' => $path.'\CustomerController@customerUpdateIntakeQuestion']);

        $router->get('customers/current-active-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCurrentActivePlan']);
        $router->get('customer-subscription-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSubscriptionPlan']);

        $router->get('customer-other-plan-list', ['as' => 'users', 'uses' => $path.'\CustomerController@customerOtherPlanList']);

        $router->post('customers/subscription-payment', ['as' => 'users', 'uses' => $path.'\CustomerController@customerSubscriptionPayment']);

        $router->put('customer-cancel-subscription-plan', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCancelSubscriptionPlan']);

        $router->post('customers/two-factor-enable-disable', ['as' => 'users', 'uses' => $path.'\CustomerController@customerTwoFactorEnableDisable']); 

        $router->post('customers/session-token', ['as' => 'users', 'uses' => $path.'\CustomerController@sessionToken']); 
        $router->post('customers/join-session', ['as' => 'users', 'uses' => $path.'\CustomerController@customerJoinSession']); 
        $router->post('customers/save-video-session-detail', ['as' => 'providers', 'uses' => $path.'\CustomerController@customerSaveVideoSessionDetail']); 
        
        $router->get('customers/no-show-time', ['as' => 'users', 'uses' => $path.'\CustomerController@customerNoShowTime']); 

        $router->post('customers/notification-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@noShowNotificationToProvider']); 

        $router->post('customers/session-did-not-join-notification-to-provider', ['as' => 'users', 'uses' => $path.'\CustomerController@sessionDidNotJoinNotificationToProvider']); 

        $router->put('customers/change-language', ['as' => 'users', 'uses' => $path.'\CustomerController@changeLanguage']);

        $router->post('customers/delete-customer-account', ['as' => 'users', 'uses' => $path.'\CustomerController@deleteCustomerAccount']); 

        $router->get('customers', ['as' => 'users', 'uses' => $path.'\CustomerController@index']);
        $router->get('archived/customers', ['as' => 'users', 'uses' => $path.'\CustomerController@archivedCustomers']);
        $router->get('customers/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@show']);
        $router->delete('customers/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@archiveCustomer']);

        $router->delete('customers/delete/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@deleteCustomer']);

        $router->put('customers/{id}/active-inactive', ['as' => 'users', 'uses' => $path . '\CustomerController@activeInactive']);

        $router->put('customers/unarchive/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@unarchiveCustomer']);

        $router->put('customers/unblock/{id}', ['as' => 'users', 'uses' => $path . '\CustomerController@unblockCustomer']);

        $router->post('customers/update/{id}', ['as' => 'users', 'uses' => $path.'\CustomerController@updateCustomer']);

        // dashboard 
            $router->get('customers-count', ['as' => 'users', 'uses' => $path.'\CustomerController@customerCount']);
        //

        // end my route
        



        //$router->get('customers/search', ['as' => 'users', 'uses' => $path.'\CustomerController@index']);
        //$router->get('customers/myinfo', ['as' => 'users', 'uses' => $path.'\CustomerController@showMyInfo']);
        $router->post('customers/{id}/reset_password', ['as' => 'vendors', 'uses' => $path . '\CustomerController@resetPassword']);
        $router->put('customer/{id}/active_inactive', ['as' => 'vendors', 'uses' => $path . '\CustomerController@activeInactive']);
        $router->get('customer/{id}/profile_picture', ['as' => 'users', 'uses' => $path . '\CustomerController@viewAvatar']);

        // my jobs
        $router->get('customers/{id}/jobs', ['as' => 'jobs', 'uses' => $path.'\JobsController@allCustomerJobs']);
        
        $router->post('customers/update-remaining-appointment', ['as' => 'vendors', 'uses' => $path . '\CustomerController@update_remaining_appointment_consumer']);
    
        $router->post('customers/accesscode-subscription-payment', ['as' => 'users', 'uses' => $path.'\CustomerController@customerAccessCodeSubscriptionPayment']);

    
    });
});
