<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */

// Custom push api
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "CustomPushes";
    $router->get('custom_pushes', ['as' => 'push', 'uses' => $path . '\CustomPushController@index']);
    $router->post('custom_pushes', ['as' => 'push', 'uses' => $path . '\CustomPushController@store']);
    $router->put('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@update']);
    $router->delete('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@delete']);
    $router->get('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@show']);
    $router->get('custom_push/count', ['as' => 'push', 'uses' => $path . '\CustomPushController@count']);
    $router->get('custom_push_check', ['as' => 'push', 'uses' => $path . '\CustomPushController@check']);
});

//**** Subcodevs v3 api ******/

$router->group(['prefix' => 'api/v3/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v3\CustomPushes";
    $router->get('custom_pushes', ['as' => 'push', 'uses' => $path . '\CustomPushController@index']);
    $router->post('custom_pushes', ['as' => 'push', 'uses' => $path . '\CustomPushController@store']);
    $router->put('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@update']);
    $router->delete('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@delete']);
    $router->get('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@show']);
    $router->get('custom_push/count', ['as' => 'push', 'uses' => $path . '\CustomPushController@count']);
    $router->get('custom_push_check', ['as' => 'push', 'uses' => $path . '\CustomPushController@check']);
});

//**** Subcodevs v4 api ******/

$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v4\CustomPushes";
    $router->get('custom_pushes', ['as' => 'push', 'uses' => $path . '\CustomPushController@index']);
    $router->post('custom_pushes', ['as' => 'push', 'uses' => $path . '\CustomPushController@store']);
    $router->put('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@update']);
    $router->delete('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@delete']);
    $router->get('custom_pushes/{id}', ['as' => 'push', 'uses' => $path . '\CustomPushController@show']);
    $router->get('custom_push/count', ['as' => 'push', 'uses' => $path . '\CustomPushController@count']);
    $router->get('custom_push_check', ['as' => 'push', 'uses' => $path . '\CustomPushController@check']);
});
