<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */

// Newsletter api
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "Newsletters";
    $router->get('newsletters', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@index']);
    $router->post('newsletters', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@store']);
    $router->delete('newsletters/{id}', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@destroy']);
});


//**** Subcodevs v3 api ******/

// Newsletter api
$router->group(['prefix' => 'api/v3/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v3\Newsletters";
    $router->get('newsletters', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@index']);
    $router->post('newsletters', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@store']);
    $router->delete('newsletters/{id}', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@destroy']);
});


//**** Subcodevs v4 api ******/

// Newsletter api
$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v4\Newsletters";
    $router->get('newsletters', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@index']);
    $router->post('newsletters', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@store']);
    $router->delete('newsletters/{id}', ['as' => 'newsletter', 'uses' => $path . '\NewsletterController@destroy']);
});