<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */

// Payment api
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "Payments";
    $router->get('payment', ['as' => 'payment', 'uses' => $path . '\PaymentController@index']);
    $router->post('payment', ['as' => 'payment', 'uses' => $path . '\PaymentController@store']);
    $router->get('payment/orders', ['as' => 'payment', 'uses' => $path . '\PaymentController@getOrderWiseCommission']);
});


//**** Subcodevs v3 api ******/


// Payment api
$router->group(['prefix' => 'api/v3/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v3\Payments";
    $router->get('payment', ['as' => 'payment', 'uses' => $path . '\PaymentController@index']);
    $router->post('payment', ['as' => 'payment', 'uses' => $path . '\PaymentController@store']);
    $router->get('payment/orders', ['as' => 'payment', 'uses' => $path . '\PaymentController@getOrderWiseCommission']);
});


//**** Subcodevs v4 api ******/


// Payment api
$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v4\Payments";
    $router->get('payment', ['as' => 'payment', 'uses' => $path . '\PaymentController@index']);
    $router->post('payment', ['as' => 'payment', 'uses' => $path . '\PaymentController@store']);
    $router->get('payment/orders', ['as' => 'payment', 'uses' => $path . '\PaymentController@getOrderWiseCommission']);
});