<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */

// Posts api
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "Posts";
    $router->get('posts', ['as' => 'posts', 'uses' => $path . '\PostController@index']);
    $router->post('posts', ['as' => 'posts', 'uses' => $path . '\PostController@store']);
    $router->put('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@update']);
    $router->delete('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@delete']);
    $router->get('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@show']);
    $router->get('post/count', ['as' => 'posts', 'uses' => $path . '\PostController@count']);
});

// Posts reaction api
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "Posts";
    $router->post('posts/reaction', ['as' => 'posts', 'uses' => $path . '\PostReactionController@store']);
    $router->delete('posts/reaction/{id}', ['as' => 'posts', 'uses' => $path . '\PostReactionController@delete']);
});


//**** Subcodevs v3 api ******/


// Posts api
$router->group(['prefix' => 'api/v3/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v3\Posts";
    $router->get('posts', ['as' => 'posts', 'uses' => $path . '\PostController@index']);
    $router->post('posts', ['as' => 'posts', 'uses' => $path . '\PostController@store']);
    $router->put('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@update']);
    $router->delete('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@delete']);
    $router->get('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@show']);
    $router->get('post/count', ['as' => 'posts', 'uses' => $path . '\PostController@count']);
});

// Posts reaction api
$router->group(['prefix' => 'api/v3/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v3\Posts";
    $router->post('posts/reaction', ['as' => 'posts', 'uses' => $path . '\PostReactionController@store']);
    $router->delete('posts/reaction/{id}', ['as' => 'posts', 'uses' => $path . '\PostReactionController@delete']);
});



//**** Subcodevs v4 api ******/


// Posts api
$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v4\Posts";
    $router->get('posts', ['as' => 'posts', 'uses' => $path . '\PostController@index']);
    $router->post('posts', ['as' => 'posts', 'uses' => $path . '\PostController@store']);
    $router->put('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@update']);
    $router->delete('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@delete']);
    $router->get('posts/{id}', ['as' => 'posts', 'uses' => $path . '\PostController@show']);
    $router->get('post/count', ['as' => 'posts', 'uses' => $path . '\PostController@count']);
});

// Posts reaction api
$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v4\Posts";
    $router->post('posts/reaction', ['as' => 'posts', 'uses' => $path . '\PostReactionController@store']);
    $router->delete('posts/reaction/{id}', ['as' => 'posts', 'uses' => $path . '\PostReactionController@delete']);
});

