<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */

$router->post('api/v2/admin-setting', ['as' => 'setting', 'uses' => 'Settings\SettingCotroller@adminSettingValue']);

$router->post('api/v2/get-latest-app-version', ['as' => 'setting', 'uses' => 'Settings\SettingCotroller@getLatestAppVersion']);
$router->get('api/v2/get-latest-app-version-all', ['as' => 'setting', 'uses' => 'Settings\SettingCotroller@getLatestAppVersionAll']);
$router->post('api/v2/update-app-version', ['as' => 'setting', 'uses' => 'Settings\SettingCotroller@updateLatestAppVersion']);
// Setting api
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "Settings";
    $router->get('setting', ['as' => 'setting', 'uses' => $path . '\SettingCotroller@index']);
    $router->put('setting', ['as' => 'setting', 'uses' => $path . '\SettingCotroller@update']);

    $router->post('setting/app-configuration',['as' => 'setting', 'uses' => $path . '\SettingCotroller@appConfigurationSave']);
});


//**** Subcodevs v3 api ******/

$router->post('api/v3/admin-setting', ['as' => 'setting', 'uses' => 'v3\Settings\SettingCotroller@adminSettingValue']);

$router->post('api/v3/get-latest-app-version', ['as' => 'setting', 'uses' => 'v3\Settings\SettingCotroller@getLatestAppVersion']);
$router->get('api/v3/get-latest-app-version-all', ['as' => 'setting', 'uses' => 'v3\Settings\SettingCotroller@getLatestAppVersionAll']);
$router->post('api/v3/update-app-version', ['as' => 'setting', 'uses' => 'v3\Settings\SettingCotroller@updateLatestAppVersion']);
// Setting api
$router->group(['prefix' => 'api/v3/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v3\Settings";
    $router->get('setting', ['as' => 'setting', 'uses' => $path . '\SettingCotroller@index']);
    $router->put('setting', ['as' => 'setting', 'uses' => $path . '\SettingCotroller@update']);

    $router->post('setting/app-configuration',['as' => 'setting', 'uses' => $path . '\SettingCotroller@appConfigurationSave']);
});


//**** Subcodevs v4 api ******/

$router->post('api/v4/admin-setting', ['as' => 'setting', 'uses' => 'v4\Settings\SettingCotroller@adminSettingValue']);

$router->post('api/v4/get-latest-app-version', ['as' => 'setting', 'uses' => 'v4\Settings\SettingCotroller@getLatestAppVersion']);
$router->get('api/v4/get-latest-app-version-all', ['as' => 'setting', 'uses' => 'v4\Settings\SettingCotroller@getLatestAppVersionAll']);
$router->post('api/v4/update-app-version', ['as' => 'setting', 'uses' => 'v4\Settings\SettingCotroller@updateLatestAppVersion']);
// Setting api
$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v4\Settings";
    $router->get('setting', ['as' => 'setting', 'uses' => $path . '\SettingCotroller@index']);
    $router->put('setting', ['as' => 'setting', 'uses' => $path . '\SettingCotroller@update']);

    $router->post('setting/app-configuration',['as' => 'setting', 'uses' => $path . '\SettingCotroller@appConfigurationSave']);
});

$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router)
{
    $path = "v4\Settings";
    $router->post('evergreen/add', ['as' => 'setting', 'uses' => $path . '\SettingCotroller@evergreen_store']);
    $router->get('evergreen/list',['as'=>'setting','uses'=>$path.'\SettingCotroller@evergreen_list']);
    $router->get('get_evergreen_content/{id}',['as'=>'setting','uses'=>$path.'\SettingCotroller@get_evergreen_content']);
    $router->put('evergreen/{id}/active-inactive', ['as' => 'setting', 'uses' => $path . '\SettingCotroller@activeInactive']);
    $router->post('evergreen/update',['as'=>'setting','uses'=>$path.'\SettingCotroller@evergreenUpdate']);
    $router->delete('/evergreen/delete/{id}',['as'=>'setting','uses'=>$path.'\SettingCotroller@evergreendelete']);

  

});