<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */


// Wallet api
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "Wallets";
    $router->get('wallets', ['as' => 'wallets', 'uses' => $path . '\WalletController@index']);
    $router->post('wallets', ['as' => 'wallets', 'uses' => $path . '\WalletController@store']);
    $router->put('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@update']);
    $router->get('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@show']);
    $router->delete('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@delete']);
    $router->get('wallet/count', ['as' => 'wallets', 'uses' => $path . '\WalletController@count']);
});


//**** Subcodevs v3 api ******/


// Wallet api
$router->group(['prefix' => 'api/v3/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v3\Wallets";
    $router->get('wallets', ['as' => 'wallets', 'uses' => $path . '\WalletController@index']);
    $router->post('wallets', ['as' => 'wallets', 'uses' => $path . '\WalletController@store']);
    $router->put('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@update']);
    $router->get('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@show']);
    $router->delete('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@delete']);
    $router->get('wallet/count', ['as' => 'wallets', 'uses' => $path . '\WalletController@count']);
});


//**** Subcodevs v4 api ******/


// Wallet api
$router->group(['prefix' => 'api/v4/', 'middleware' => 'auth'], function () use ($router) 
{
    $path = "v4\Wallets";
    $router->get('wallets', ['as' => 'wallets', 'uses' => $path . '\WalletController@index']);
    $router->post('wallets', ['as' => 'wallets', 'uses' => $path . '\WalletController@store']);
    $router->put('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@update']);
    $router->get('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@show']);
    $router->delete('wallets/{id}', ['as' => 'wallets', 'uses' => $path . '\WalletController@delete']);
    $router->get('wallet/count', ['as' => 'wallets', 'uses' => $path . '\WalletController@count']);
});

