<?php

/** @var \Laravel\Lumen\Routing\Router $router */
/*
  |--------------------------------------------------------------------------
  | Application Routes
  |--------------------------------------------------------------------------
  |
  | Here is where you can register all of the routes for an application.
  | It is a breeze. Simply tell Lumen the URIs it should respond to
  | and give it the Closure to call when that URI is requested.
  |
 */

//  foreach (scandir(__DIR__.'/../App/Http/Controllers/v3') as $filename)
//  {
//    if($filename != '.' && $filename != '..' ){
//         foreach (scandir(__DIR__.'/../App/Http/Controllers/v3/'.$filename) as $filename2)
//         {
//             if ($filename2 == '.' || $filename2 == '..') {
        
//                 continue;
//             }
            
//             require __DIR__.'../../App/Http/Controllers/v3/'.$filename.'/'.$filename2;
//             // require __DIR__.'/../routes/'.$filename;
//         }
//     }
         
//  }

// includes('../App/Http/Controllers/v3/Customers/CustomerController.php')

use App\Http\Controllers\v3\Customers\CustomerController;

$router->get('/', function () use ($router) {

    return $router->app->version();
});
$router->post('/test-notification','Controller@notification');
$router->post('/message','Controller@testMsg');
$router->post('/test', 'Controller@test');

$router->get('/api/v2/php_info', function () use ($router) {
    echo "<pre>";
    print_r(auth()->access_token);
    echo "you are here";
    die;
});

$router->get('/send-email','TestController@sendMail');
$router->get('/encrypt-data/{name}/{address}','TestController@encryptData');
$router->get('/decrypt-data/{name}/{address}','TestController@decryptData');
$router->post('/encrypt-data-1','TestController@encryptData1');
$router->post('/decrypt-data-1','TestController@decryptData1');

$router->get('/upload-doc','TestController@upload');
$router->post('/upload-doc','TestController@uploadDoc');
$router->get('/show-doc','TestController@showDoc');
$router->get('/activity-log','TestController@activityLog');
$router->get('/push-notification','TestController@sendPushNotification');

$router->get('/create-data','TestController@creatData');
$router->get('/fetch-data','TestController@fetchData');


$router->get('/creat-test-data','TestController@creatTestData');
$router->get('/fetch-test-data','TestController@fetchTestData');

/* Stripe charge payment   */
$router->get('/charge-payment','TestController@chargePayment');
$router->get('/create-customer','TestController@createCustomer');
$router->get('/create-product','TestController@createProduct');
$router->get('/create-price','TestController@createPrice');
$router->get('/create-plan','TestController@createPlan');
$router->get('/create-subscription','TestController@createSubscription');
$router->get('/cancel-subscription','TestController@cancelSubscription');

//**********Role's scopes manage 






// My favourites API
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) {
    $path = "Favourites";
    $router->get('favourites', ['as' => 'favourites', 'uses' => $path . '\FavouriteController@index']);
    $router->get('favourites/search', ['as' => 'favourites', 'uses' => $path . '\FavouriteController@index']);
    $router->post('favourites', ['as' => 'favourites', 'uses' => $path . '\FavouriteController@store']);
    $router->get('favourites/{id}', ['as' => 'favourites', 'uses' => $path . '\FavouriteController@show']);
    $router->put('favourites/{id}', ['as' => 'favourites', 'uses' => $path . '\FavouriteController@update']);
    $router->delete('favourites/{id}', ['as' => 'favourites', 'uses' => $path . '\FavouriteController@delete']);
});






// rate the app
$router->group(['prefix' => 'api/v2/', 'middleware' => 'auth'], function () use ($router) {
    $path = "RateTheApp";
    $router->get('rate-app', ['as' => 'rate-app', 'uses' => $path . '\RateAppController@index']);
    $router->get('rate-app/search', ['as' => 'rate-app', 'uses' => $path . '\RateAppController@index']);
    $router->post('rate-app', ['as' => 'rate-app', 'uses' => $path . '\RateAppController@store']);
    $router->put('rate-app/{id}', ['as' => 'rate-app', 'uses' => $path . '\RateAppController@update']);
    $router->delete('rate-app/{id}', ['as' => 'rate-app', 'uses' => $path . '\RateAppController@delete']);
});




foreach (scandir(__DIR__.'/../routes') as $filename)
{
    if ($filename == '.' || $filename == '..' || $filename == 'web.php') {
        
        continue;
    }
    
    require __DIR__.'/../routes/'.$filename;
}
